﻿// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2018-05-24T09:28:07, by ESR Version 1.72.0.0 using ESR Database 
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using Ato.EN.IntegrationServices.Document.DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationDFRL
{

    public partial class DFRL2018Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="DFRL2018Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public DFRL2018Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        /// <summary>
        /// Get string value between [first] a and [last] b.
        /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

        /// <summary>
        /// Get string value after [first] a.
        /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

        /// <summary>
        /// Get string value after [last] a.
        /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
                return 0;
            else
                return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return ((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            nodes = nodes.Where(x => x != null).ToArray();
            return !((from x in nodes select x).Distinct().Count() == nodes.Count());

        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }
        //The logic in After function expects "---" for day and "--" for month. 
        //Since hyphen was missing the date always returned null
        public DateTime? ConvertToDate(int day, int month, int year)
        {
            return ConvertToDate(day == 0 ? null : "---" + day.ToString(), month == 0 ? null : "--" + month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }

        private static DateTime? AddMonthsToDate(DateTime? dateTime, int months)
        {
            return dateTime == null ? null : (DateTime?)dateTime.Value.AddMonths(months);
        }

        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length < 13 || abn.Length < 11)
                {
                    response = false;
                }
                else
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 2), out numeric))
                        response = false;
                    else if (Regex.IsMatch(usi, @"^[a-zA-Z]{3}\d{4}[a-zA-Z]{2}"))
                        response = false;
                    else
                        response = true;
                }
            }
            return response;
        }


        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
            return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
            decimal numberValue;
            decimal.TryParse(value, out numberValue);
            return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags = "")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':
                        options = options | RegexOptions.IgnoreCase;
                        break;
                    case 'm':
                        options = options | RegexOptions.Multiline;
                        break;
                    case 's':
                        options = options | RegexOptions.Singleline;
                        break;
                    case 'n':
                        options = options | RegexOptions.ExplicitCapture;
                        break;
                    case 'x':
                        options = options | RegexOptions.IgnorePatternWhitespace;
                        break;
                }
            }

            return options;
        }

        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public DFRL2018 ConsumedReport { get; private set; }

        private static Dictionary<string, ProcessMessageDocument> _processMessageDocuments = new Dictionary<string, ProcessMessageDocument>();

        [MethodImpl(MethodImplOptions.AggressiveInlining)]
        public List<ProcessMessageDocument> ValidateReport(DFRL2018 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------


            #region VR.ATO.DFRL.000001

            /*  VR.ATO.DFRL.000001
            The Australian Business Number (ABN) of the Registered agent must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^DFRL1 <> NULL) AND (FailsABNAlgorithm(^DFRL1))

            Technical Business Rule Format:
            (^DFRL1 <> NULL) AND (FailsABNAlgorithm(^DFRL1))
    
            Data Elements:
    
            ^DFRL1 = DFRL:INT:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.DFRL1 != null && FailsABNAlgorithm(report.DFRL1));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered agent ABN is invalid.",
                    LongDescription = @"The Australian Business Number (ABN) of the Registered agent has failed the algorithm check.",
                    Location = "/tns:DFRL/tns:INT/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL1", Value = report.DFRL1 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000001

            #region VR.ATO.DFRL.000002

            /*  VR.ATO.DFRL.000002
            The Registered Agent number (RAN) must pass the RAN algorithm check.
    
            Legacy Rule Format:
            (^DFRL2 <> NULL) AND (((Length(^DFRL2) =7) AND (FailsTANAlgorithm(Concat('0', ^DFRL2)))) OR ((Length(^DFRL2) =8) AND (FailsTANAlgorithm(^DFRL2))))

            Technical Business Rule Format:
            (^DFRL2 <> NULL) AND (((Length(^DFRL2) = 7) AND (FailsTANAlgorithm(Concat('0', ^DFRL2)))) OR ((Length(^DFRL2) =8) AND (FailsTANAlgorithm(^DFRL2))))
    
            Data Elements:
    
            ^DFRL2 = DFRL:INT:Identifiers.TaxAgentNumber.Identifier
            */
            assertion = (report.DFRL2 != null && (Length(report.DFRL2) == 7 && FailsTANAlgorithm(string.Concat(@"0", report.DFRL2)) || Length(report.DFRL2) == 8 && FailsTANAlgorithm(report.DFRL2)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000002",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Registered Agent Number is invalid.",
                    LongDescription = @"The Registered Agent Number (RAN) of the Registered agent has failed the algorithm check.",
                    Location = "/tns:DFRL/tns:INT/tns:TaxAgentNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL2", Value = report.DFRL2 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000002

            #region VR.ATO.DFRL.000003

            /*  VR.ATO.DFRL.000003
            The Tax File Number (TFN) of the Client must pass the TFN algorithm check.
    
            Legacy Rule Format:
            (^DFRL3 <> NULL) AND (FailsTFNAlgorithm(^DFRL3))

            Technical Business Rule Format:
            (^DFRL3 <> NULL) AND (FailsTFNAlgorithm(^DFRL3))
    
            Data Elements:
    
            ^DFRL3 = DFRL:RP:Identifiers.TaxFileNumber.Identifier
            */
            assertion = (report.DFRL3 != null && FailsTFNAlgorithm(report.DFRL3));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000003",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid TFN provided.",
                    LongDescription = @"The Tax File Number (TFN) of the Client has failed the algorithm check.",
                    Location = "/tns:DFRL/tns:RP/tns:TaxFileNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL3", Value = report.DFRL3 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000003

            #region VR.ATO.DFRL.000004

            /*  VR.ATO.DFRL.000004
            The Australian Business Number (ABN) of the Client must pass the ABN algorithm check.
    
            Legacy Rule Format:
            (^DFRL4 <> NULL) AND (FailsABNAlgorithm(^DFRL4))

            Technical Business Rule Format:
            (^DFRL4 <> NULL) AND (FailsABNAlgorithm(^DFRL4))
    
            Data Elements:
    
            ^DFRL4 = DFRL:RP:Identifiers.AustralianBusinessNumber.Identifier
            */
            assertion = (report.DFRL4 != null && FailsABNAlgorithm(report.DFRL4));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000004",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Client ABN is invalid.",
                    LongDescription = @"The Australian Business Number (ABN) of the Client has failed the algorithm check.",
                    Location = "/tns:DFRL/tns:RP/tns:AustralianBusinessNumberId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000004" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL4", Value = report.DFRL4 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000004

            #region VR.ATO.DFRL.000007

            /*  VR.ATO.DFRL.000007
            Value must consist of a valid Role type code
    
            Legacy Rule Format:
            (^DFRL7 <> NULL) AND (NotInSet(^DFRL7,'"ITI","ITC","ITT","ITSF","ITP","ITCGH","FBT","ASR","GSTAR"'))

            Technical Business Rule Format:
            (^DFRL7 <> NULL) AND (NotInSet(^DFRL7,'"ITI","ITC","ITT","ITSF","ITP","ITCGH","FBT","ASR","GSTAR"'))
    
            Data Elements:
    
            ^DFRL7 = DFRL:RP:Tax.RoleType.Code
            */
            assertion = (report.DFRL7 != null && !(IsMatch(report.DFRL7, @"^(ITI|ITC|ITT|ITSF|ITP|ITCGH|FBT|ASR|GSTAR)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000007",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid Role type code provided.",
                    LongDescription = @"Role type code must be a valid value.
Valid values are:
ITI = Income Tax - Individual
ITC = Income Tax - Company
ITT = Income Tax - Trust
ITSF = Income Tax - Super Fund
ITP = Income Tax - Partnership
ITCGH = Income Tax Consolidated Group Head
FBT = Fringe Benefits Tax
ASR = Activity Statement Reporting
GSTAR = GST Annual Reporting",
                    Location = "/tns:DFRL/tns:RP/tns:TaxRoleTypeC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000007" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL7", Value = report.DFRL7 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000007

            #region VR.ATO.DFRL.000012

            /*  VR.ATO.DFRL.000012
            Value must consist of a valid Deferral reason.
    
            Legacy Rule Format:
            (^DFRL12 <> NULL) AND (NotInSet(^DFRL12,'"SeriousIllness","ImpededAccess","Disaster","NewClient"'))

            Technical Business Rule Format:
            (^DFRL12 <> NULL) AND (NotInSet(^DFRL12,'"SeriousIllness","ImpededAccess","Disaster","NewClient"'))
    
            Data Elements:
    
            ^DFRL12 = DFRL:RP:Obligation.DeferralReason.Code
            */
            assertion = (report.DFRL12 != null && !(IsMatch(report.DFRL12, @"^(SeriousIllness|ImpededAccess|Disaster|NewClient)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000012",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid Deferral reason provided.",
                    LongDescription = @"Deferral reason must be a valid value.
Valid values are:
SeriousIllness = Serious illness of the practitioner, staff member or taxpayer where it impacts on
lodgment and/or payment by the due date.
ImpededAccess = Impeded access to records, eg records have been seized for evidence, not been
received from another agent, the records are temporarily inaccessible due to a
serious computer failure, or wind up action by an administrator.
Disaster = Natural and other disasters, eg flood, fire, cyclone or a similar disaster that impacts
on lodgment and/or payment by the due date.
NewClient = New or Re-engaged Clients",
                    Location = "/tns:DFRL/tns:RP/tns:ObligationDeferralReasonC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000012" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL12", Value = report.DFRL12 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000012

            #region VR.ATO.DFRL.000013

            /*  VR.ATO.DFRL.000013
            Value must have a maximum length of 3000 characters.
    
            Legacy Rule Format:
            (^DFRL13 <> NULLORBLANK) AND (Length(^DFRL13) > 3000)

            Technical Business Rule Format:
            Length(^DFRL13) > 3000
    
            Data Elements:
    
            ^DFRL13 = DFRL:RP:Obligation.DeferralReason.Description
            */
            assertion = (Length(report.DFRL13) > 3000);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000013",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Client deferral reason description length is too long.",
                    LongDescription = @"Deferral reason description must be a maximum of 3000 characters.",
                    Location = "/tns:DFRL/tns:RP/tns:ObligationDeferralReasonDe",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000013" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL13", Value = report.DFRL13 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000013

            #region VR.ATO.DFRL.000014

            /*  VR.ATO.DFRL.000014
            Value must consist of a valid Deferral reason.
    
            Legacy Rule Format:
            (^DFRL14 <> NULL) AND
            (NotInSet(^DFRL14,'"SeriousIllness","ImpededAccess","Disaster","NewClient"'))

            Technical Business Rule Format:
            (^DFRL14 <> NULL) AND (NotInSet(^DFRL14,'"SeriousIllness","ImpededAccess","Disaster","NewClient"'))
    
            Data Elements:
    
            ^DFRL14 = DFRL:INT:Obligation.DeferralReason.Code
            */
            assertion = (report.DFRL14 != null && !(IsMatch(report.DFRL14, @"^(SeriousIllness|ImpededAccess|Disaster|NewClient)$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000012",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid Deferral reason provided.",
                    LongDescription = @"Deferral reason must be a valid value.
Valid values are:
SeriousIllness = Serious illness of the practitioner, staff member or taxpayer where it impacts on
lodgment and/or payment by the due date.
ImpededAccess = Impeded access to records, eg records have been seized for evidence, not been
received from another agent, the records are temporarily inaccessible due to a
serious computer failure, or wind up action by an administrator.
Disaster = Natural and other disasters, eg flood, fire, cyclone or a similar disaster that impacts
on lodgment and/or payment by the due date.
NewClient = New or Re-engaged Clients",
                    Location = "/tns:DFRL/tns:INT/tns:ObligationDeferralReasonC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000014" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL14", Value = report.DFRL14 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000014

            #region VR.ATO.DFRL.000015

            /*  VR.ATO.DFRL.000015
            Value must have a maximum length of 3000 characters.
    
            Legacy Rule Format:
            (^DFRL15 <> NULLORBLANK) AND (Length(^DFRL15) > 3000)

            Technical Business Rule Format:
            Length(^DFRL15) > 3000
    
            Data Elements:
    
            ^DFRL15 = DFRL:INT:Obligation.DeferralReason.Description
            */
            assertion = (Length(report.DFRL15) > 3000);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000015",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Agent deferral reason description length is too long.",
                    LongDescription = @"Deferral reason description must be a maximum of 3000 characters.",
                    Location = "/tns:DFRL/tns:INT/tns:ObligationDeferralReasonDe",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000015" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL15", Value = report.DFRL15 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000015

            #region VR.ATO.DFRL.000016

            assertion = (report.DFRL15 != null && !(IsMatch(report.DFRL15, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ _""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000016",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Agent deferral reason description contains invalid text.",
                    //LongDescription = @"",
                    Location = "/tns:DFRL/tns:INT/tns:ObligationDeferralReasonDe",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000016" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL15", Value = report.DFRL15 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000016

            #region VR.ATO.DFRL.000017

            assertion = (report.DFRL13 != null && !(IsMatch(report.DFRL13, @"^[a-z,A-Z,0-9,""!@\$%&\*\(\)\-=\[\];:'"",\.\?/ _""]*$", RegexOptions.IgnoreCase)));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.000017",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Agent deferral reason description contains invalid text.",
                    //LongDescription = @"",
                    Location = "/tns:DFRL/tns:RP/tns:ObligationDeferralReasonDe",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.000017" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL13", Value = report.DFRL13 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.000017

            #region VR.ATO.DFRL.100001

            /*  VR.ATO.DFRL.100001
            Agent deferral reason and/or Client Deferral reason must be provided.
    
            Legacy Rule Format:
            (^DFRL14 = NULL) AND (^DFRL12 = NULL)

            Technical Business Rule Format:
            (^DFRL14 = NULL) AND (^DFRL12 = NULL)
    
            Data Elements:
    
            ^DFRL14 = DFRL:INT:Obligation.DeferralReason.Code
    
            ^DFRL12 = DFRL:RP:Obligation.DeferralReason.Code
            */
            assertion = (report.DFRL14 == null && report.DFRL12 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.100001",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"No deferral reason was provided.",
                    LongDescription = @"An Agent deferral reason and/or Client deferral reason must be provided.",
                    Location = "/tns:DFRL/tns:INT/tns:ObligationDeferralReasonC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.100001" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL14", Value = report.DFRL14 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL12", Value = report.DFRL12 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.100001

            #region VR.ATO.DFRL.100002

            /*  VR.ATO.DFRL.100002
            Agent deferral reason must be provided where the Agent deferral reason description has been provided.
    
            Legacy Rule Format:
            (^DFRL14 = NULL) AND (^DFRL15 <> NULLORBLANK)

            Technical Business Rule Format:
            (^DFRL14 = NULL) AND (^DFRL15 <> BLANK)
    
            Data Elements:
    
            ^DFRL14 = DFRL:INT:Obligation.DeferralReason.Code
    
            ^DFRL15 = DFRL:INT:Obligation.DeferralReason.Description
            */
            assertion = (report.DFRL14 == null && string.IsNullOrWhiteSpace(report.DFRL15) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.100002",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"No Agent deferral reason was provided.",
                    LongDescription = @"An Agent deferral reason must be provided where an Agent deferral reason description has been provided.",
                    Location = "/tns:DFRL/tns:INT/tns:ObligationDeferralReasonC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.100002" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL14", Value = report.DFRL14 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL15", Value = report.DFRL15 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.100002

            #region VR.ATO.DFRL.100003

            /*  VR.ATO.DFRL.100003
            Account identifier and/or Account sequence number must be provided
    
            Legacy Rule Format:
            (^DFRL5 = NULL) AND (^DFRL6 = NULL)

            Technical Business Rule Format:
            (^DFRL5 = NULL) AND (^DFRL6 = NULL)
    
            Data Elements:
    
            ^DFRL5 = DFRL:RP:Tax.Account.Identifier
    
            ^DFRL6 = DFRL:RP:Tax.AccountSequence.Number
            */
            assertion = (report.DFRL5 == null && report.DFRL6 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.100003",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Account Identifier and/or Account Sequence Number not provided.",
                    LongDescription = @"A valid Account Identifier and/or Account Sequence Number must be provided.",
                    Location = "/tns:DFRL/tns:RP/tns:TaxAccountId",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.100003" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL5", Value = report.DFRL5 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL6", Value = report.DFRL6.GetValueOrDefault().ToString() });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.100003

            #region VR.ATO.DFRL.100007

            /*  VR.ATO.DFRL.100007
            New lodgment due date and/or New payment due date must be provided
    
            Legacy Rule Format:
            (^DFRL10 = NULL) AND (^DFRL11 = NULL)

            Technical Business Rule Format:
            (^DFRL10 = NULL) AND (^DFRL11 = NULL)
    
            Data Elements:
    
            ^DFRL10 = DFRL:RP:Lodgment.Due.Date
    
            ^DFRL11 = DFRL:RP:PaymentRecord.Due.Date
            */
            assertion = (report.DFRL10 == null && report.DFRL11 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.100007",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"New Lodgment Due Date and/or Payment Due Date not provided.",
                    LongDescription = @"A New Lodgment Due Date and/or Payment Due Date must be provided.",
                    Location = "/tns:DFRL/tns:RP/tns:LodgmentDueD",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.100007" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL10", Value = GetValueOrEmpty(report.DFRL10) });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL11", Value = GetValueOrEmpty(report.DFRL11) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.100007

            #region VR.ATO.DFRL.100010

            /*  VR.ATO.DFRL.100010
            Client deferral reason must be provided where the Client deferral reason description has been provided.
    
            Legacy Rule Format:
            (^DFRL12 = NULL) AND (^DFRL13 <> NULLORBLANK)

            Technical Business Rule Format:
            (^DFRL12 = NULL) AND (^DFRL13 <> BLANK)
    
            Data Elements:
    
            ^DFRL12 = DFRL:RP:Obligation.DeferralReason.Code
    
            ^DFRL13 = DFRL:RP:Obligation.DeferralReason.Description
            */
            assertion = (report.DFRL12 == null && string.IsNullOrWhiteSpace(report.DFRL13) != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.100010",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"No Client deferral reason was provided.",
                    LongDescription = @"Client deferral reason must be provided where the Client deferral reason description has been provided.",
                    Location = "/tns:DFRL/tns:RP/tns:ObligationDeferralReasonC",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.100010" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL12", Value = report.DFRL12 });

                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL13", Value = report.DFRL13 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.100010

            #region VR.ATO.DFRL.100011

            /*  VR.ATO.DFRL.100011
            If 'Intermediary Declaration' tuple is provided, Intermediary Signature Indicator must be 'TRUE'.
    
            Legacy Rule Format:
            ((^DFRL102 <> NULL) AND (^DFRL16 <> TRUE))

            Technical Business Rule Format:
            ((^DFRL102 <> NULL) AND (^DFRL16 <> TRUE))
    
            Data Elements:
    
            ^DFRL16 = DFRL:INT:Declaration:Declaration.StatementAccepted.Indicator
    
            ^DFRL102 = DFRL:INT:Declaration
            */
            assertion = (report.InT_DeclarationCollectionExists != false && report.DFRL16 != true);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.100011",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"Declaration signature indicator must be true.",
                    Location = "/tns:DFRL/tns:INT/tns:Declaration/tns:StatementAcceptedI",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.100011" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL16", Value = GetValueOrEmpty(report.DFRL16) });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.100011

            #region VR.ATO.DFRL.100012

            /*  VR.ATO.DFRL.100012
            The declaration must be provided by intermediary.
    
            Legacy Rule Format:
            ((^DFRL100 <> NULL) AND (^DFRL17 = NULL))

            Technical Business Rule Format:
            ((^DFRL100 <> NULL) AND (^DFRL17 = NULL))
    
            Data Elements:
    
            ^DFRL17 = DFRL:INT:Declaration:Declaration.SignatoryIdentifier.Text
    
            ^DFRL100 = DFRL:INT
            */
            assertion = (report.IntCollectionExists != false && report.DFRL17 == null);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.DFRL.100012",
                    Severity = ProcessMessageSeverity.Error,
                    Description = @"The sender's Declaration is not provided.",
                    LongDescription = @"The Declaration must be provided by the Intermediary.",
                    Location = "/tns:DFRL/tns:INT/tns:Declaration/tns:SignatoryIdentifierT",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() { Name = "RuleIdentifier", Value = "VR.ATO.DFRL.100012" } },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                { Name = "DFRL17", Value = report.DFRL17 });

                response.Add(processMessage);
            }
            #endregion // VR.ATO.DFRL.100012

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
}
